#    Copyright (C) 2004  Corporation of Balclutha. All rights Reserved.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import os
from StringIO import StringIO

from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.TypesTool import ContentFactoryMetadata

from Products.Zpydoc.config import *

def install(self):                                       
    out = StringIO()

    typestool = getToolByName(self, 'portal_types')
    for t in factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)
            out.write('Registered %s with the types tool (%s)\n' % (typestool.absolute_url(), t['id']))
        else:
            out.write('Object "%s" already existed in the types tool\n' % (
                t['id']))


    skins_tool = getToolByName(self, 'portal_skins')
    if SKINNAME not in skins_tool.objectIds():
        addDirectoryViews(skins_tool, 'skins', GLOBALS)
        out.write("Added %s directory view to portal_skins\n" % SKINNAME)
 
    skins = skins_tool.getSkinSelections()
    
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = [p.strip() for p in path.split(',') if p]
        if SKINNAME not in path:
            if path:
                path.insert(1, SKINNAME)
            else:
                path.insert(0, SKINNAME)
        skins_tool.addSkinSelection(skin, ','.join(path))
                                                                                               
    print >> out, 'Installed %s layer to skins' % SKINNAME
                                                                                               
    wf = getToolByName(self, 'portal_workflow')
    wf.setChainForPortalTypes(('Zpydoc',), 'folder_workflow')
    wf.setChainForPortalTypes(('ZpydocPage',), '')
                                                                                                   
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

def uninstall(self):
    out = StringIO()

    typestool = getToolByName(self, 'portal_types')
    for t in factory_type_information:
        if t['id'] in typestool.objectIds():
            typestool._delObject(t['id'])
    
    skins_tool = getToolByName(self, 'portal_skins')
    skins = skins_tool.getSkinSelections()
    
    for skin in skins:
        path = skins_tool.getSkinPath(skin)
        path = [p.strip() for p in path.split(',') if p]
        if SKINNAME in path:
            path.remove(SKINNAME)

