#    Copyright (C) 2003-2005  Corporation of Balclutha. All rights Reserved.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
__doc__ = """$id$"""
__version__='$Revision: 62 $'[11:-2]
import Globals, Interface, Products
from AccessControl.Permissions import change_configuration, view_management_screens, \
     manage_properties, change_permissions, undo_changes, access_contents_information

try:
    from Products.OrderedFolder.OrderedFolder import OrderedFolder
    Folder = OrderedFolder
except:
    from OFS.Folder import Folder

class IZpydocRenderer( Interface.Base ):
    """
    this is our renderer quasi-ZClass

    note that each renderer MUST implement this interface, and MUST
    supply a global function of the form manage_add<__classname__>Renderer(self, REQUEST=None)
    for our factory generator
    """
    def __init__(self):
        """
        a default ctor IS required ie no parameters ...
        """
    def page(self, object):
        """
        handle publishing a package/module...
        """

    def builtins(self):
        """
        handle publishing builtin functions
        """

    def index(self, path, seen):
        """
        build a list of package modules for the main index page
        """

class RendererFolder(Folder):
    """ """
    meta_type = 'RendererFolder'

    __ac_permissions__ = (
        (view_management_screens, ('manage_main','manage_findFrame', 'manage_findForm',
                                   'manage_findAdv', 'manage_findResult')),
        (manage_properties, ('manage_addProperty', 'manage_editProperties',
                             'manage_delProperties', 'manage_changeProperties',
                             'manage_propertiesForm', 'manage_propertyTypeForm',
                             'manage_changePropertyTypes', )),
        (access_contents_information,  ('hasProperty', 'propertyIds', 'propertyValues',
                                        'propertyItems', 'getProperty', 'getPropertyType',
                                        'propertyMap'), ('Anonymous', 'Manager') ),
        (change_permissions,  ('manage_access', 'permission_settings', 'ac_inherited_permissions',
                               'manage_roleForm', 'manage_role', 'manage_acquiredForm',
                               'manage_acquiredPermissions', 'manage_permissionForm',
                               'manage_permission', 'manage_changePermissions', 'permissionsOfRole',
                               'rolesOfPermission', 'acquiredRolesAreUsedBy', 'manage_defined_roles',
                               'userdefined_roles', 'manage_listLocalRoles', 'manage_editLocalRoles',
                               'manage_setLocalRoles', 'manage_addLocalRoles', 'manage_delLocalRoles' )),
        (undo_changes, ('manage_undo_transactions', 'undoable_transactions', 'manage_UndoForm' )),
        )

    id = 'renderers'
    title = ''

    # don't want 'View'
    manage_options = ( Folder.manage_options[0], ) + Folder.manage_options[2:]
    index_html = None
    
    def all_meta_types(self):
        possibles = []
        for iface in Products.meta_types:
            try:
                if IZpydocRenderer in iface.get('interfaces', []):
                    possibles.append(iface)
	    except TypeError:
		pass
        definites = map(lambda x: x.meta_type, self.objectValues())
        return filter(lambda x,y=definites: x['name'] not in y, possibles)

Globals.InitializeClass(RendererFolder)
